#!@PERL@
#
# splitdiff - split up a diff made of incremental patches
# Copyright (C) 2001  Tim Waugh <twaugh@redhat.com>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

use Getopt::Std;
getopts('p:v-:', \%opts);
if ($opts{'-'} && $opts{'-'} eq 'version') {
    print "splitdiff - patchutils version @VERSION@\n";
    exit 0;
}
if ($opts{'-'} && $opts{'-'} eq 'help') {
    print "usage: splitdiff [OPTIONS] FILE\n";
    print "OPTIONS are:\n";
    print "  -p N            pathname components to ignore\n";
    exit 0;
}

$part = 1;
sub process {
    print "Lines $_[0] to $_[1]\n" if ($opts{v});
    $out = $ARGV[0].'.part'.$part;
    open(OLDOUT, ">&STDOUT");
    open(STDOUT, '>', $out) or die "Can't open output file\n";
    select(STDOUT); $| = 1;
    system ('sed', '-ne', $_[0].','.$_[1].'p', $ARGV[0]);
    close(STDOUT);
    open(STDOUT, ">&OLDOUT");
    print "Wrote ".$out."\n";
    $part++;
}

if($#ARGV != 0) {
    die "usage: splitdiff DIFF\n";
}
$getlist = 'lsdiff -n ';
$getlist .= '-p'.$opts{p}.' ' if ($opts{p});
$getlist .= $ARGV[0]; # Yuck.  How do you do this properly in perl?
open(LIST, '-|', $getlist) or die "Can't run lsdiff";
@list = <LIST>;
close LIST;

%seen = ();
@this = ();
$ready = 0;
for (@list) {
    /\s*(\d+)\s*(.*)$/;
    my ($linenum, $file) = ($1, $2);
    if ($ready == 1) {
	process ($firstline, $linenum - 1);
	$ready = 0;
    }
    push @this, [ $linenum, $file ];
    if ($seen{$file}) {
	$firstline = $this[0]->[0];
	$ready = 1;
	if ($opts{v}) {
	    for (@this) {
		print $_->[0].": ".$_->[1]."\n";
	    }
	    print "\n";
	}
	@this = ();
    }
    $seen{$file} = $file;
}
process ($firstline, '$') if $ready == 1;

if ($part == 1) {
    print "Input contained no duplicate files; nothing to do\n";
}
